import java.awt.Color;

/*
 * @(#)JaveMovieFrame.java  1.2  23rd December 2001 Markus Gebhard
 * @(#)JaveMovieFrame.java  1.1  11th July 2001 Markus Gebhard
 * @(#)JaveMovieFrame.java  1.0  28th June 2001 Markus Gebhard
 * @(#)JaveMovieFrame.java  0.1  10th June 2001 Markus Gebhard
 * 
 * This Software is Open Source. You are allowed to change anything,
 * but there are some limitations:
 *
 *  - You must always include the source code
 *  - You are not allowed to remove this Header from the source code
 *  - You have to add a link to http://www.jave.de so people know
 *    where to find the original version and information about it
 *  - You have to let me know about new releases
 *
 *                                      Markus Gebhard  markus@jave.de
 */

/**
An object of this class is a single frame in a Jave "movie".

The information in this frame is packed and will be unpacked as soon
as you request the data by calling getContent() or getSelection().

A frame has information about
 - its content,
 - the duration in milliseconds it shall be displayed
 - the color (null if not specified)
In addition, if used as a protocol/log file for editing documents with Jave:
 - the selection content and position (if any)
 - the scroll position of the editor window
 - the cursor position
 - the tool used for this step of editing
 - the action that has been performed by editing
*/

public class JaveMovieFrame{
  protected String content;
  protected String selection;
  protected String action;
  protected String tool;
  protected int selectionX;
  protected int selectionY;
  protected int cursorX;
  protected int cursorY;
  protected int scrollX;
  protected int scrollY;
  protected int duration;
  protected Color foreground;
  protected Color background;
  protected boolean isSoundTrigger=false;
  
public JaveMovieFrame(){
}

public JaveMovieFrame duplicate(){
  JaveMovieFrame f=new JaveMovieFrame();
  f.content=content;
  f.selection=selection;
  f.action=action;
  f.tool=tool;
  f.selectionX=selectionX;
  f.selectionY=selectionY;
  f.cursorX=cursorX;
  f.cursorY=cursorY;
  f.scrollX=scrollX;
  f.scrollY=scrollY;
  f.duration=duration;
  
  f.foreground=foreground;
  f.background=background;
  f.isSoundTrigger=isSoundTrigger;
  
  return f;
}

public boolean isSoundTrigger(){
  return isSoundTrigger;
}

public void setSoundTrigger(boolean what){
  isSoundTrigger=what;
}

public void print(){
  System.err.println("Content: "+content);
  System.err.println("Selection: "+selection);
  System.err.println("Action: "+action);
  System.err.println("Tool: "+tool);
}
  
public char[][] getContent(){
  return AsciiPacker.decode(content);
}
  
public char[][] getSelection(){
  if (selection==null)
    return null;
    
  return AsciiPacker.decode(selection);
}



public boolean isEmpty(){
  //Quick and dirty... (could also be found out by looking at the compressed code!)
  char[][] ch=getContent();
  if (ch.length==0 || ch[0].length==0)
    return true;
    
  int w=ch[0].length;
  int h=ch.length;
  
  for (int y=0;y<h;++y)
    for (int x=0;x<w;++x)
      if (ch[y][x]!=' ')
        return false;  
      
  return true;
}


public String getAction(){
  return this.action;
}

public void setAction(String action){
  this.action = action;
}

public void setContent(String content){
  this.content = content;
}
 
public int getCursorX(){
  return this.cursorX;
}

public void setCursorX(int cursorX){
  this.cursorX = cursorX;
}
  
public int getCursorY(){
  return this.cursorY;
}

public void setCursorY(int cursorY){
  this.cursorY = cursorY;
}
  
public int getScrollX(){
  return this.scrollX;
}

public void setScrollX(int scrollX){
  this.scrollX = scrollX;
}

public int getScrollY(){
  return this.scrollY;
}

public void setScrollY(int scrollY){
  this.scrollY = scrollY;
}

public void setSelection(String selection){
  this.selection = selection;
}
  
public int getSelectionX(){
  return this.selectionX;
}

public void setSelectionX(int selectionX){
  this.selectionX = selectionX;
}

public int getSelectionY(){
  return this.selectionY;
}

public void setSelectionY(int selectionY){
  this.selectionY = selectionY;
}
  
public String getTool(){
  return this.tool;
}

public void setTool(String tool){
  this.tool = tool;
}

public void setDuration(int duration){
  this.duration=duration;
}

public int getDuration(){
  return this.duration;
}

public void setForeground(Color foreground){
  this.foreground=foreground;
}

public Color getForeground(){
  return this.foreground;
}


public void setBackground(Color background){
// System.err.println("setBack("+background+")"); 
  
  this.background=background;
}

public Color getBackground(){
  return this.background;
}

public String toString(){
  return "JaveMovieFrame["+duration+" "+foreground+" "+background+"]";
}

}