/*
 * @(#)JavePlayerTools.java  1.2  23rd December 2001 Markus Gebhard
 * @(#)JavePlayerTools.java  1.1  11th July 2001 Markus Gebhard
 * 
 * This Software is Open Source. You are allowed to change anything,
 * but there are some limitations:
 *
 *  - You must always include the source code
 *  - You are not allowed to remove this Header from the source code
 *  - You have to add a link to http://www.jave.de so people know
 *    where to find the original version and information about it
 *  - You have to let me know about new releases
 *
 *                                      Markus Gebhard  markus@jave.de
 */

import java.awt.Color;

/**
This class provides a set of utility methodes.
*/

public class JavePlayerTools{

  /** It is not possible to create an instance of this class */
  private JavePlayerTools(){}
  
  
/**
* Converts 'color' to a hex string representation, e.g. #FF120A
*/
public final static String colorToHex(Color color){
  String red   = Integer.toHexString(color.getRed());
  String green = Integer.toHexString(color.getGreen());
  String blue  = Integer.toHexString(color.getBlue());
   
  if (red.length()==1)
    red="0"+red;
  if (green.length()==1)
    green="0"+green;
  if (blue.length()==1)
    blue="0"+blue;

  return "#"+red+green+blue;
}

public static Color hexToColor(String color){  
  if (color.length()==6)
    color=color.toLowerCase();
  else
  if (color.length()==7)
    color=color.substring(1).toLowerCase();
  else
    throw new RuntimeException("Wrong format for color: "+color);

  int red   = 16*hexToInt(color.charAt(0))+hexToInt(color.charAt(1));
  int green = 16*hexToInt(color.charAt(2))+hexToInt(color.charAt(3));
  int blue  = 16*hexToInt(color.charAt(4))+hexToInt(color.charAt(5));
  
  return new Color(red,green,blue);
}
  
protected final static int hexToInt(char ch){  
  if (ch>='0' && ch<='9')
    return (ch-'0');
  else
  if (ch>='a' && ch<='f')
    return (10+ch-'a');
  else
    throw new RuntimeException("Wrong format for hexadecimal number: "+ch);
}

}