/*
 * @(#)ZIPTool.java  1.2  23rd December 2001 Markus Gebhard
 * @(#)ZIPTool.java  1.0  28th June 2001 Markus Gebhard
 * @(#)ZIPTool.java  0.1  10th June 2001 Markus Gebhard
 * 
 * This Software is Open Source. You are allowed to change anything,
 * but there are some limitations:
 *
 *  - You must always include the source code
 *  - You are not allowed to remove this Header from the source code
 *  - You have to add a link to http://www.jave.de so people know
 *    where to find the original version and information about it
 *  - You have to let me know about new releases
 *
 *                                      Markus Gebhard  markus@jave.de
 */

import java.io.*;
import java.util.zip.*;
import java.net.URL;
import java.net.MalformedURLException;

public class ZIPTool{
  private ZIPTool(){}

public static URL toUrl(String name){
  URL url=null;
  try{
    url = new URL(name);
  }catch(MalformedURLException e1){
    File file=new File(name);
    try{
      url=toURL(file);
    }catch(MalformedURLException e2){
      return null;
    }
  }
  return url;
}

public static URL toURL(File file) throws MalformedURLException{
  //Source from JDK1.2.2 File.toUrl() - it is not available in JDK1.1
  String path = file.getAbsolutePath();
  if (File.separatorChar != '/') {
    path = path.replace(File.separatorChar, '/');
  }
  if (!path.startsWith("/")) {
    path = "/" + path;
  }
  if (!path.endsWith("/") && file.isDirectory()) {
    path = path + "/";
  }
  return new URL("file", "", path);
}

public static boolean isZipped(File file){
  try{
    return isZipped(toURL(file));
  }catch(MalformedURLException e){
  }
  return false;
}

public static boolean isZipped(URL url){
  try{
    DataInputStream testIS=new DataInputStream(url.openStream());
    if (testIS.readByte()==80 &&
        testIS.readByte()==75 &&
        testIS.readByte()==3 &&
        testIS.readByte()==4){
      return true;
    }
    testIS.close();
  }catch(IOException e){
  }

  return false;
}

public static BufferedReader openPossiblyZipped(URL url) throws IOException{
  BufferedReader dis=null;

  if (isZipped(url)){
    try{
      DataInputStream datis = new DataInputStream(url.openStream());
      ZipInputStream zis=new ZipInputStream(datis);
      zis.getNextEntry();
      dis= new BufferedReader(new InputStreamReader(zis));
    } catch (ZipException e){
      System.err.println("ZipException "+e);
      return null;
    }
  }else{
    dis= new BufferedReader(new InputStreamReader(url.openStream()));
  }
  return dis;
}

}